DROP VIEW V_POGODBE;

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE, P.ID_PRIVEZ, P.BLOCK_OUT, P.APPROVED_BY, P.APPROVED_ON, P.ID_OWNER_SIGNATURE,
  (CASE WHEN P.BLOCK_OUT = 'Y' AND P.DATUM_ZACETKA IS NOT NULL AND P.DATUM_KONCA IS NOT NULL THEN P.DATUM_KONCA + 1 ELSE NULL END) AS BLOCK_OUT_FROM,
  (CASE WHEN P.BLOCK_OUT = 'Y' AND P.DATUM_ZACETKA IS NOT NULL AND P.DATUM_KONCA IS NOT NULL THEN P.DATUM_KONCA + (P.DATUM_KONCA - P.DATUM_ZACETKA) + 1 ELSE NULL END) AS BLOCK_OUT_TO,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK, KUP.INT_CODE AS KUPCI_INT_CODE, KUP.VRSTA AS KUPCI_VRSTA,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ, NP.DOLZINA AS NNPRIVEZ_DOLZINA, 
  NO.OPIS AS NNOBJEKT_OPIS, NO.INTERNI_OPIS AS NNOBJEKT_INTERNI_OPIS, NO.STORAGE AS NNOBJEKT_STORAGE, NNLOC.ID AS NNLOCATION_ID,
  (SELECT SUM((MV.SKUPAJ + (MV.SKUPAJ*COALESCE(MV.DAVEK,0)/100))*(1 - (COALESCE(MV.POPUST, 0)/100))*(1 - (COALESCE(MV.POPUST1, 0)/100))*(1 - (COALESCE(MV.POPUST2, 0)/100))) FROM M_VZORCI_PS MV WHERE MV.ID_POGODBE = P.ID_POGODBE AND MV.STORNO IS NULL) AS PRICE, 
  (SELECT SUM((MV.SKUPAJ + (MV.SKUPAJ*COALESCE(MV.DAVEK,0)/100))*(1 - (COALESCE(MV.POPUST, 0)/100))*(1 - (COALESCE(MV.POPUST1, 0)/100))*(1 - (COALESCE(MV.POPUST2, 0)/100))) FROM M_VZORCI_PS MV WHERE MV.ID_POGODBE = P.ID_POGODBE_GEN AND MV.STORNO IS NULL) AS PREVIOUS_PRICE, 
	(CASE WHEN ((SELECT COUNT(*) FROM M_VZORCI_PS WHERE ID_POGODBE = P.ID_POGODBE AND STORNO IS NULL) > 0 AND (SELECT COUNT(*) FROM M_VZORCI_PS WHERE ID_POGODBE = P.ID_POGODBE AND STORNO IS NULL AND ACTIVE = 'Y') = 0) THEN 'Y' ELSE 'N' END) AS FULLY_CHARGED
  FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
);

ALTER TABLE NPRIKLJ
ADD STATE_CHECK VARCHAR2(1 CHAR);

DROP VIEW V_NNPRIKLJ;

CREATE OR REPLACE VIEW V_NNPRIKLJ AS (
SELECT NN.NNPRIKLJ_ID, NN.ID_PRIVEZ, NN.OZNAKA, NN.PRIKLJ, NN.ZACETNO_STANJE, NN.KONCNO_STANJE, NN.ZASEDEN, NN.INTERNI_OPIS, NN.OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE, NN.EXT_PONTOON, NN.EXT_SOCKET, 
NN.VOLTAGE, NN.AMPERAGE, NN.EUUS, NN.METER_HW_VALUE, NN.EXT_ID,
N.OPIS AS NPRIKLJ_OPIS, N.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS, N.STORITEV AS NPRIKLJ_STORITEV, N.NPRIKLJ_TYPE AS NPRIKLJ_TYPE, N.STATE_CHECK AS NPRIKLJ_STATE_CHECK,
P.ID_PRIKLJ AS PRIKLJ_ID_PRIKLJ, P.ID_LASTNIKA AS PRIKLJ_ID_LASTNIKA, P.ID_PLOVILA AS PRIKLJ_ID_PLOVILA, P.ID AS PRIKLJ_ID, P.ID_STORITVE AS PRIKLJ_ID_STORITVE, P.OZNAKA AS PRIKLJ_OZNAKA, 
P.PRIKLJUCEK AS PRIKLJ_PRIKLJUCEK, P.DATUM_ZACETKA AS PRIKLJ_DATUM_ZACETKA, P.DATUM_KONCA AS PRIKLJ_DATUM_KONCA, P.ZACETNO_STANJE AS PRIKLJ_ZACETNO_STANJE, P.KONCNO_STANJE AS PRIKLJ_KONCNO_STANJE, 
P.ZASEDEN AS PRIKLJ_ZASEDEN, P.OBRACUNAN AS PRIKLJ_OBRACUNAN, P.STEVEC_HW_STANJE AS PRIKLJ_STEVEC_HW_STANJE,
NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NNP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NNP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NNPOM.SORT AS NNPOMOL_SORT,
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, VPL.NNLOCATION_ID, VOL.OPIS AS VOLTAGE_OPIS, AMP.OPIS AS AMPERAGE_OPIS, EUS.OPIS AS EUUS_OPIS,
COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE) AS PREVIOUS_STATE
FROM NNPRIKLJ NN
JOIN (SELECT NNI.NNPRIKLJ_ID, CASE WHEN (NNI.ZASEDEN = 'Y') THEN (SELECT MAX(PI.ID_PRIKLJ) FROM PRIKLJ PI WHERE PI.NNPRIKLJ_ID=NNI.NNPRIKLJ_ID) ELSE NULL END AS PRIKLJ_ID FROM NNPRIKLJ NNI) NNI ON NNI.NNPRIKLJ_ID = NN.NNPRIKLJ_ID 
LEFT OUTER JOIN NPRIKLJ N ON NN.OZNAKA=N.SIFRA
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL NNPOM ON NNPOM.SIFRA = NNP.KATEGORIJA
LEFT OUTER JOIN PRIKLJ P ON P.ID_PRIKLJ = NNI.PRIKLJ_ID
LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPL ON VPL.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NN_VOLTAGE VOL ON VOL.ID = NN.VOLTAGE
LEFT OUTER JOIN NN_AMPERAGE AMP ON AMP.ID = NN.AMPERAGE
LEFT OUTER JOIN NN_EUUS EUS ON EUS.ID = NN.EUUS
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1755, SYSDATE, '5.5', 1675, 'VPogodbe')
;
