ALTER TABLE REPORT_SQL
ADD TIME1 TIMESTAMP
;

ALTER TABLE REPORT_SQL
ADD TIME2 TIMESTAMP
;

ALTER TABLE REPORT_SQL
ADD TIME3 TIMESTAMP
;

ALTER TABLE REPORT_SQL
ADD TIME4 TIMESTAMP
;

DROP VIEW V_KUPCI;

CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.TELEFON_2, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, K.DATUM_SPREMEMBE, K.DATUM_KREIRANJA, K.ID_STATE, K.STATE,
	K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM, K.BELEZKA, K.MANAGER, K.ACT, K.KODA_JEZIKA, K.CODE_REFERRAL, K.LOYALTY, K.LOYALTY_CODE, K.DAVCNA_STEVILKA, K.SEND_TEXT, K.ID_EXTERNAL, K.DATE_EXTERNAL, K.UNSUBSCRIBED,
  ENQ.INITIAL_CONTACT_DATE, ENQ.SELL_PHASE, ENQ.BOAT_LOCATION_ID, ENQ.SELL_PHASE_STATUS AS SELL_PHASE_STATUS, ENQ.BOAT_LENGTH_ID AS ENQUIRY_BOAT_LENGTH_ID,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.OPIS AS VRSTA_OPIS, NNVRS.INTERNI_OPIS AS VRSTA_DESC, NNVRSLOY.OPIS AS LOYALTY_TYPE_DESCRIPTION,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC, NNUSR.USER_ AS MANAGER_USER,
  NSP.OPIS AS SELL_PHASE_OPIS, NNLB.OPIS AS BOAT_LOCATION_OPIS,
  (SELECT LISTAGG(NV.OPIS,', ') WITHIN GROUP(ORDER BY NV.OPIS ASC) TYPES FROM KUPCI_VRSTA KV, NNVRSKUP NV WHERE NV.SIFRA = KV.VRSTA AND KV.ID_KUPCA = K.ID) AS TYPES_DESCRIPTIONS,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
  ENQ.CONVERSION_DATE, K.START_YC_MEMBERSHIP, LAST_DATE.LAST_CONTACT_DATE
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
  LEFT OUTER JOIN NNVRSKUP NNVRSLOY ON K.LOYALTY_CODE = NNVRSLOY.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN ENQUIRY ENQ ON K.ID = ENQ.ID_KUPCA
  LEFT OUTER JOIN NNSELL_PHASE NSP ON ENQ.SELL_PHASE = NSP.SIFRA
  LEFT OUTER JOIN NNLOCATION NNLB ON ENQ.BOAT_LOCATION_ID = NNLB.ID
  LEFT OUTER JOIN (SELECT ID_KUPCA, MAX(LAST_DATE) AS LAST_CONTACT_DATE FROM 
(select IDKUPCA AS ID_KUPCA, MAX(DATUMKREIRANJA) AS LAST_DATE FROM KUPCIBELEZKE WHERE VELJAVNA='Y' AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromNotes')=1 group by IDKUPCA
union
select KA1.ID_KUPCA, MAX(AK1.DATE_FROM) AS LAST_DATE FROM KUPCI_ACTIVITY KA1 JOIN ACTIVITY AK1 ON KA1.ID_ACTIVITY=AK1.ID_ACTIVITY WHERE AK1.STATUS='N' AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromActivities')=1 group by KA1.ID_KUPCA
union
select O1.ID AS ID_KUPCA, MAX(E1.DATUM_POSILJANJA) AS LAST_DATE FROM OPOMINI O1 JOIN EMAILS E1 ON E1.ID_EMAIL = O1.ID_EMAIL WHERE (O1.NPISMO = (SELECT N1.NPISMO FROM NPISMO N1 WHERE N1.NPISMO_TYPE = 'EMAIL')) AND E1.STATUS=2 AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromEmails')=1 group by O1.ID
union
select O2.ID AS ID_KUPCA, MAX(S2.DATE_CREATED) AS LAST_DATE FROM OPOMINI O2 JOIN SMS S2 ON S2.ID = O2.ID_SMS WHERE (O2.NPISMO = 'S') AND (select vrednost from S_NASTAVITVE WHERE NAZIV='OwnerLastContactDateFromSms')=1 group by O2.ID
) LCD GROUP BY LCD.ID_KUPCA) LAST_DATE ON LAST_DATE.ID_KUPCA=K.ID
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2128, SYSDATE, '5.5', 2048, 'V_KUPCI')
;
